unit schObrasServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, schObrasClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_ObrasDelta = '{0FE5B98C-4F8D-48A9-8BF4-6BFF0383CE55}';
  RID_ContactosObraDelta = '{1D653815-22DF-4649-BF15-4B5B5910F7F5}';
  RID_RefrescoContactosObraDelta = '{02BE5448-ED9F-4CCF-806D-090B64CF2203}';
  RID_RefrescoObrasDelta = '{113D238F-84F5-4FD0-A17A-E788E65A8E80}';
  RID_PresupuestosObraDelta = '{C355E15B-778E-470E-8B21-43FA2C9E0C82}';
  RID_RefrescoPresupuestosObraDelta = '{35D54105-8EA1-41C9-9011-98C38F530621}';
  RID_ProyectosObraDelta = '{0369AC96-A644-4E5C-B42F-8C710266D30F}';

type
  { IObrasDelta }
  IObrasDelta = interface(IObras)
  ['{0FE5B98C-4F8D-48A9-8BF4-6BFF0383CE55}']
    { Property getters and setters }
    function GetOldCODIGOEMPRESAValue : Integer;
    function GetOldCODIGOValue : Integer;
    function GetOldFECHAALTAValue : DateTime;
    function GetOldUSUARIOValue : String;
    function GetOldNOMBREValue : String;
    function GetOldFECHAINIOBRValue : DateTime;
    function GetOldFECHAFINOBRValue : DateTime;
    function GetOldCALLEValue : String;
    function GetOldCODIGOPOSTALValue : String;
    function GetOldPOBLACIONValue : String;
    function GetOldPROVINCIAValue : String;
    function GetOldTIPOValue : String;
    function GetOldDIMENSIONESValue : Integer;
    function GetOldHONORARIOSValue : Float;
    function GetOldIMPORTEHONORARIOSValue : Currency;
    function GetOldAPLICAHONORARIOSValue : String;
    function GetOldTOTALPRESUPUESTOSINIValue : Currency;
    function GetOldTOTALPRESUPUESTOSFINValue : Currency;
    function GetOldCODIGOCONTACTOValue : Integer;
    function GetOldNOMBRECLIENTEValue : String;

    { Properties }
    property OldCODIGOEMPRESA : Integer read GetOldCODIGOEMPRESAValue;
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldFECHAINIOBR : DateTime read GetOldFECHAINIOBRValue;
    property OldFECHAFINOBR : DateTime read GetOldFECHAFINOBRValue;
    property OldCALLE : String read GetOldCALLEValue;
    property OldCODIGOPOSTAL : String read GetOldCODIGOPOSTALValue;
    property OldPOBLACION : String read GetOldPOBLACIONValue;
    property OldPROVINCIA : String read GetOldPROVINCIAValue;
    property OldTIPO : String read GetOldTIPOValue;
    property OldDIMENSIONES : Integer read GetOldDIMENSIONESValue;
    property OldHONORARIOS : Float read GetOldHONORARIOSValue;
    property OldIMPORTEHONORARIOS : Currency read GetOldIMPORTEHONORARIOSValue;
    property OldAPLICAHONORARIOS : String read GetOldAPLICAHONORARIOSValue;
    property OldTOTALPRESUPUESTOSINI : Currency read GetOldTOTALPRESUPUESTOSINIValue;
    property OldTOTALPRESUPUESTOSFIN : Currency read GetOldTOTALPRESUPUESTOSFINValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property OldNOMBRECLIENTE : String read GetOldNOMBRECLIENTEValue;
  end;

  { TObrasBusinessProcessorRules }
  TObrasBusinessProcessorRules = class(TDABusinessProcessorRules, IObras, IObrasDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOEMPRESAValue: Integer; virtual;
    function GetOldCODIGOEMPRESAValue: Integer; virtual;
    procedure SetCODIGOEMPRESAValue(const aValue: Integer); virtual;
    function GetCODIGOValue: Integer; virtual;
    function GetOldCODIGOValue: Integer; virtual;
    procedure SetCODIGOValue(const aValue: Integer); virtual;
    function GetFECHAALTAValue: DateTime; virtual;
    function GetOldFECHAALTAValue: DateTime; virtual;
    procedure SetFECHAALTAValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    function GetOldUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    function GetOldNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetFECHAINIOBRValue: DateTime; virtual;
    function GetOldFECHAINIOBRValue: DateTime; virtual;
    procedure SetFECHAINIOBRValue(const aValue: DateTime); virtual;
    function GetFECHAFINOBRValue: DateTime; virtual;
    function GetOldFECHAFINOBRValue: DateTime; virtual;
    procedure SetFECHAFINOBRValue(const aValue: DateTime); virtual;
    function GetCALLEValue: String; virtual;
    function GetOldCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetCODIGOPOSTALValue: String; virtual;
    function GetOldCODIGOPOSTALValue: String; virtual;
    procedure SetCODIGOPOSTALValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    function GetOldPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    function GetOldPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    function GetOldTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetDIMENSIONESValue: Integer; virtual;
    function GetOldDIMENSIONESValue: Integer; virtual;
    procedure SetDIMENSIONESValue(const aValue: Integer); virtual;
    function GetHONORARIOSValue: Float; virtual;
    function GetOldHONORARIOSValue: Float; virtual;
    procedure SetHONORARIOSValue(const aValue: Float); virtual;
    function GetIMPORTEHONORARIOSValue: Currency; virtual;
    function GetOldIMPORTEHONORARIOSValue: Currency; virtual;
    procedure SetIMPORTEHONORARIOSValue(const aValue: Currency); virtual;
    function GetAPLICAHONORARIOSValue: String; virtual;
    function GetOldAPLICAHONORARIOSValue: String; virtual;
    procedure SetAPLICAHONORARIOSValue(const aValue: String); virtual;
    function GetTOTALPRESUPUESTOSINIValue: Currency; virtual;
    function GetOldTOTALPRESUPUESTOSINIValue: Currency; virtual;
    procedure SetTOTALPRESUPUESTOSINIValue(const aValue: Currency); virtual;
    function GetTOTALPRESUPUESTOSFINValue: Currency; virtual;
    function GetOldTOTALPRESUPUESTOSFINValue: Currency; virtual;
    procedure SetTOTALPRESUPUESTOSFINValue(const aValue: Currency); virtual;
    function GetCODIGOCONTACTOValue: Integer; virtual;
    function GetOldCODIGOCONTACTOValue: Integer; virtual;
    procedure SetCODIGOCONTACTOValue(const aValue: Integer); virtual;
    function GetNOMBRECLIENTEValue: String; virtual;
    function GetOldNOMBRECLIENTEValue: String; virtual;
    procedure SetNOMBRECLIENTEValue(const aValue: String); virtual;

    { Properties }
    property CODIGOEMPRESA : Integer read GetCODIGOEMPRESAValue write SetCODIGOEMPRESAValue;
    property OldCODIGOEMPRESA : Integer read GetOldCODIGOEMPRESAValue;
    property CODIGO : Integer read GetCODIGOValue write SetCODIGOValue;
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property FECHAALTA : DateTime read GetFECHAALTAValue write SetFECHAALTAValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property USUARIO : String read GetUSUARIOValue write SetUSUARIOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property FECHAINIOBR : DateTime read GetFECHAINIOBRValue write SetFECHAINIOBRValue;
    property OldFECHAINIOBR : DateTime read GetOldFECHAINIOBRValue;
    property FECHAFINOBR : DateTime read GetFECHAFINOBRValue write SetFECHAFINOBRValue;
    property OldFECHAFINOBR : DateTime read GetOldFECHAFINOBRValue;
    property CALLE : String read GetCALLEValue write SetCALLEValue;
    property OldCALLE : String read GetOldCALLEValue;
    property CODIGOPOSTAL : String read GetCODIGOPOSTALValue write SetCODIGOPOSTALValue;
    property OldCODIGOPOSTAL : String read GetOldCODIGOPOSTALValue;
    property POBLACION : String read GetPOBLACIONValue write SetPOBLACIONValue;
    property OldPOBLACION : String read GetOldPOBLACIONValue;
    property PROVINCIA : String read GetPROVINCIAValue write SetPROVINCIAValue;
    property OldPROVINCIA : String read GetOldPROVINCIAValue;
    property TIPO : String read GetTIPOValue write SetTIPOValue;
    property OldTIPO : String read GetOldTIPOValue;
    property DIMENSIONES : Integer read GetDIMENSIONESValue write SetDIMENSIONESValue;
    property OldDIMENSIONES : Integer read GetOldDIMENSIONESValue;
    property HONORARIOS : Float read GetHONORARIOSValue write SetHONORARIOSValue;
    property OldHONORARIOS : Float read GetOldHONORARIOSValue;
    property IMPORTEHONORARIOS : Currency read GetIMPORTEHONORARIOSValue write SetIMPORTEHONORARIOSValue;
    property OldIMPORTEHONORARIOS : Currency read GetOldIMPORTEHONORARIOSValue;
    property APLICAHONORARIOS : String read GetAPLICAHONORARIOSValue write SetAPLICAHONORARIOSValue;
    property OldAPLICAHONORARIOS : String read GetOldAPLICAHONORARIOSValue;
    property TOTALPRESUPUESTOSINI : Currency read GetTOTALPRESUPUESTOSINIValue write SetTOTALPRESUPUESTOSINIValue;
    property OldTOTALPRESUPUESTOSINI : Currency read GetOldTOTALPRESUPUESTOSINIValue;
    property TOTALPRESUPUESTOSFIN : Currency read GetTOTALPRESUPUESTOSFINValue write SetTOTALPRESUPUESTOSFINValue;
    property OldTOTALPRESUPUESTOSFIN : Currency read GetOldTOTALPRESUPUESTOSFINValue;
    property CODIGOCONTACTO : Integer read GetCODIGOCONTACTOValue write SetCODIGOCONTACTOValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property NOMBRECLIENTE : String read GetNOMBRECLIENTEValue write SetNOMBRECLIENTEValue;
    property OldNOMBRECLIENTE : String read GetOldNOMBRECLIENTEValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IContactosObraDelta }
  IContactosObraDelta = interface(IContactosObra)
  ['{1D653815-22DF-4649-BF15-4B5B5910F7F5}']
    { Property getters and setters }
    function GetOldCODIGOOBRAValue : Integer;
    function GetOldCODIGOCONTACTOValue : Integer;
    function GetOldNOMBREValue : String;
    function GetOldCATEGORIASValue : String;

    { Properties }
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldCATEGORIAS : String read GetOldCATEGORIASValue;
  end;

  { TContactosObraBusinessProcessorRules }
  TContactosObraBusinessProcessorRules = class(TDABusinessProcessorRules, IContactosObra, IContactosObraDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOOBRAValue: Integer; virtual;
    function GetOldCODIGOOBRAValue: Integer; virtual;
    procedure SetCODIGOOBRAValue(const aValue: Integer); virtual;
    function GetCODIGOCONTACTOValue: Integer; virtual;
    function GetOldCODIGOCONTACTOValue: Integer; virtual;
    procedure SetCODIGOCONTACTOValue(const aValue: Integer); virtual;
    function GetNOMBREValue: String; virtual;
    function GetOldNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCATEGORIASValue: String; virtual;
    function GetOldCATEGORIASValue: String; virtual;
    procedure SetCATEGORIASValue(const aValue: String); virtual;

    { Properties }
    property CODIGOOBRA : Integer read GetCODIGOOBRAValue write SetCODIGOOBRAValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property CODIGOCONTACTO : Integer read GetCODIGOCONTACTOValue write SetCODIGOCONTACTOValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property CATEGORIAS : String read GetCATEGORIASValue write SetCATEGORIASValue;
    property OldCATEGORIAS : String read GetOldCATEGORIASValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IRefrescoContactosObraDelta }
  IRefrescoContactosObraDelta = interface(IRefrescoContactosObra)
  ['{02BE5448-ED9F-4CCF-806D-090B64CF2203}']
    { Property getters and setters }
    function GetOldCODIGOOBRAValue : Integer;
    function GetOldCODIGOCONTACTOValue : Integer;
    function GetOldNOMBREValue : String;
    function GetOldCATEGORIASValue : String;

    { Properties }
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldCATEGORIAS : String read GetOldCATEGORIASValue;
  end;

  { TRefrescoContactosObraBusinessProcessorRules }
  TRefrescoContactosObraBusinessProcessorRules = class(TDABusinessProcessorRules, IRefrescoContactosObra, IRefrescoContactosObraDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOOBRAValue: Integer; virtual;
    function GetOldCODIGOOBRAValue: Integer; virtual;
    procedure SetCODIGOOBRAValue(const aValue: Integer); virtual;
    function GetCODIGOCONTACTOValue: Integer; virtual;
    function GetOldCODIGOCONTACTOValue: Integer; virtual;
    procedure SetCODIGOCONTACTOValue(const aValue: Integer); virtual;
    function GetNOMBREValue: String; virtual;
    function GetOldNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCATEGORIASValue: String; virtual;
    function GetOldCATEGORIASValue: String; virtual;
    procedure SetCATEGORIASValue(const aValue: String); virtual;

    { Properties }
    property CODIGOOBRA : Integer read GetCODIGOOBRAValue write SetCODIGOOBRAValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property CODIGOCONTACTO : Integer read GetCODIGOCONTACTOValue write SetCODIGOCONTACTOValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property CATEGORIAS : String read GetCATEGORIASValue write SetCATEGORIASValue;
    property OldCATEGORIAS : String read GetOldCATEGORIASValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IRefrescoObrasDelta }
  IRefrescoObrasDelta = interface(IRefrescoObras)
  ['{113D238F-84F5-4FD0-A17A-E788E65A8E80}']
    { Property getters and setters }
    function GetOldCODIGOValue : Integer;
    function GetOldNOMBRECLIENTEValue : String;

    { Properties }
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property OldNOMBRECLIENTE : String read GetOldNOMBRECLIENTEValue;
  end;

  { TRefrescoObrasBusinessProcessorRules }
  TRefrescoObrasBusinessProcessorRules = class(TDABusinessProcessorRules, IRefrescoObras, IRefrescoObrasDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOValue: Integer; virtual;
    function GetOldCODIGOValue: Integer; virtual;
    procedure SetCODIGOValue(const aValue: Integer); virtual;
    function GetNOMBRECLIENTEValue: String; virtual;
    function GetOldNOMBRECLIENTEValue: String; virtual;
    procedure SetNOMBRECLIENTEValue(const aValue: String); virtual;

    { Properties }
    property CODIGO : Integer read GetCODIGOValue write SetCODIGOValue;
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property NOMBRECLIENTE : String read GetNOMBRECLIENTEValue write SetNOMBRECLIENTEValue;
    property OldNOMBRECLIENTE : String read GetOldNOMBRECLIENTEValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IPresupuestosObraDelta }
  IPresupuestosObraDelta = interface(IPresupuestosObra)
  ['{C355E15B-778E-470E-8B21-43FA2C9E0C82}']
    { Property getters and setters }
    function GetOldCODIGOValue : Integer;
    function GetOldCODIGOOBRAValue : Integer;
    function GetOldCODIGOCONTACTOValue : Integer;
    function GetOldFECHAALTAValue : DateTime;
    function GetOldUSUARIOValue : String;
    function GetOldFECHAValue : DateTime;
    function GetOldCLASEValue : String;
    function GetOldACEPTADOValue : Integer;
    function GetOldTIPOValue : String;
    function GetOldDESCRIPCIONValue : String;
    function GetOldPRESUPUESTOINICIALValue : Currency;
    function GetOldPRESUPUESTOFINALValue : Currency;
    function GetOldAPLICARETENCIONValue : Integer;
    function GetOldRETENCIONValue : Float;
    function GetOldTIEMPORETENCIONValue : String;
    function GetOldIMPORTERETENCIONValue : Currency;
    function GetOldNOMBREValue : String;

    { Properties }
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldCLASE : String read GetOldCLASEValue;
    property OldACEPTADO : Integer read GetOldACEPTADOValue;
    property OldTIPO : String read GetOldTIPOValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldPRESUPUESTOINICIAL : Currency read GetOldPRESUPUESTOINICIALValue;
    property OldPRESUPUESTOFINAL : Currency read GetOldPRESUPUESTOFINALValue;
    property OldAPLICARETENCION : Integer read GetOldAPLICARETENCIONValue;
    property OldRETENCION : Float read GetOldRETENCIONValue;
    property OldTIEMPORETENCION : String read GetOldTIEMPORETENCIONValue;
    property OldIMPORTERETENCION : Currency read GetOldIMPORTERETENCIONValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
  end;

  { TPresupuestosObraBusinessProcessorRules }
  TPresupuestosObraBusinessProcessorRules = class(TDABusinessProcessorRules, IPresupuestosObra, IPresupuestosObraDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOValue: Integer; virtual;
    function GetOldCODIGOValue: Integer; virtual;
    procedure SetCODIGOValue(const aValue: Integer); virtual;
    function GetCODIGOOBRAValue: Integer; virtual;
    function GetOldCODIGOOBRAValue: Integer; virtual;
    procedure SetCODIGOOBRAValue(const aValue: Integer); virtual;
    function GetCODIGOCONTACTOValue: Integer; virtual;
    function GetOldCODIGOCONTACTOValue: Integer; virtual;
    procedure SetCODIGOCONTACTOValue(const aValue: Integer); virtual;
    function GetFECHAALTAValue: DateTime; virtual;
    function GetOldFECHAALTAValue: DateTime; virtual;
    procedure SetFECHAALTAValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    function GetOldUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetFECHAValue: DateTime; virtual;
    function GetOldFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetCLASEValue: String; virtual;
    function GetOldCLASEValue: String; virtual;
    procedure SetCLASEValue(const aValue: String); virtual;
    function GetACEPTADOValue: Integer; virtual;
    function GetOldACEPTADOValue: Integer; virtual;
    procedure SetACEPTADOValue(const aValue: Integer); virtual;
    function GetTIPOValue: String; virtual;
    function GetOldTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetPRESUPUESTOINICIALValue: Currency; virtual;
    function GetOldPRESUPUESTOINICIALValue: Currency; virtual;
    procedure SetPRESUPUESTOINICIALValue(const aValue: Currency); virtual;
    function GetPRESUPUESTOFINALValue: Currency; virtual;
    function GetOldPRESUPUESTOFINALValue: Currency; virtual;
    procedure SetPRESUPUESTOFINALValue(const aValue: Currency); virtual;
    function GetAPLICARETENCIONValue: Integer; virtual;
    function GetOldAPLICARETENCIONValue: Integer; virtual;
    procedure SetAPLICARETENCIONValue(const aValue: Integer); virtual;
    function GetRETENCIONValue: Float; virtual;
    function GetOldRETENCIONValue: Float; virtual;
    procedure SetRETENCIONValue(const aValue: Float); virtual;
    function GetTIEMPORETENCIONValue: String; virtual;
    function GetOldTIEMPORETENCIONValue: String; virtual;
    procedure SetTIEMPORETENCIONValue(const aValue: String); virtual;
    function GetIMPORTERETENCIONValue: Currency; virtual;
    function GetOldIMPORTERETENCIONValue: Currency; virtual;
    procedure SetIMPORTERETENCIONValue(const aValue: Currency); virtual;
    function GetNOMBREValue: String; virtual;
    function GetOldNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;

    { Properties }
    property CODIGO : Integer read GetCODIGOValue write SetCODIGOValue;
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property CODIGOOBRA : Integer read GetCODIGOOBRAValue write SetCODIGOOBRAValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property CODIGOCONTACTO : Integer read GetCODIGOCONTACTOValue write SetCODIGOCONTACTOValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property FECHAALTA : DateTime read GetFECHAALTAValue write SetFECHAALTAValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property USUARIO : String read GetUSUARIOValue write SetUSUARIOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property FECHA : DateTime read GetFECHAValue write SetFECHAValue;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property CLASE : String read GetCLASEValue write SetCLASEValue;
    property OldCLASE : String read GetOldCLASEValue;
    property ACEPTADO : Integer read GetACEPTADOValue write SetACEPTADOValue;
    property OldACEPTADO : Integer read GetOldACEPTADOValue;
    property TIPO : String read GetTIPOValue write SetTIPOValue;
    property OldTIPO : String read GetOldTIPOValue;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property PRESUPUESTOINICIAL : Currency read GetPRESUPUESTOINICIALValue write SetPRESUPUESTOINICIALValue;
    property OldPRESUPUESTOINICIAL : Currency read GetOldPRESUPUESTOINICIALValue;
    property PRESUPUESTOFINAL : Currency read GetPRESUPUESTOFINALValue write SetPRESUPUESTOFINALValue;
    property OldPRESUPUESTOFINAL : Currency read GetOldPRESUPUESTOFINALValue;
    property APLICARETENCION : Integer read GetAPLICARETENCIONValue write SetAPLICARETENCIONValue;
    property OldAPLICARETENCION : Integer read GetOldAPLICARETENCIONValue;
    property RETENCION : Float read GetRETENCIONValue write SetRETENCIONValue;
    property OldRETENCION : Float read GetOldRETENCIONValue;
    property TIEMPORETENCION : String read GetTIEMPORETENCIONValue write SetTIEMPORETENCIONValue;
    property OldTIEMPORETENCION : String read GetOldTIEMPORETENCIONValue;
    property IMPORTERETENCION : Currency read GetIMPORTERETENCIONValue write SetIMPORTERETENCIONValue;
    property OldIMPORTERETENCION : Currency read GetOldIMPORTERETENCIONValue;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property OldNOMBRE : String read GetOldNOMBREValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IRefrescoPresupuestosObraDelta }
  IRefrescoPresupuestosObraDelta = interface(IRefrescoPresupuestosObra)
  ['{35D54105-8EA1-41C9-9011-98C38F530621}']
    { Property getters and setters }
    function GetOldCODIGOValue : Integer;
    function GetOldCODIGOOBRAValue : Integer;
    function GetOldCODIGOCONTACTOValue : Integer;
    function GetOldFECHAALTAValue : DateTime;
    function GetOldUSUARIOValue : String;
    function GetOldFECHAValue : DateTime;
    function GetOldCLASEValue : String;
    function GetOldACEPTADOValue : String;
    function GetOldTIPOValue : String;
    function GetOldDESCRIPCIONValue : String;
    function GetOldPRESUPUESTOINICIALValue : Float;
    function GetOldPRESUPUESTOFINALValue : Float;
    function GetOldAPLICARETENCIONValue : String;
    function GetOldRETENCIONValue : Float;
    function GetOldTIEMPORETENCIONValue : String;
    function GetOldIMPORTERETENCIONValue : Float;
    function GetOldNOMBREValue : String;

    { Properties }
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldCLASE : String read GetOldCLASEValue;
    property OldACEPTADO : String read GetOldACEPTADOValue;
    property OldTIPO : String read GetOldTIPOValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldPRESUPUESTOINICIAL : Float read GetOldPRESUPUESTOINICIALValue;
    property OldPRESUPUESTOFINAL : Float read GetOldPRESUPUESTOFINALValue;
    property OldAPLICARETENCION : String read GetOldAPLICARETENCIONValue;
    property OldRETENCION : Float read GetOldRETENCIONValue;
    property OldTIEMPORETENCION : String read GetOldTIEMPORETENCIONValue;
    property OldIMPORTERETENCION : Float read GetOldIMPORTERETENCIONValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
  end;

  { TRefrescoPresupuestosObraBusinessProcessorRules }
  TRefrescoPresupuestosObraBusinessProcessorRules = class(TDABusinessProcessorRules, IRefrescoPresupuestosObra, IRefrescoPresupuestosObraDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOValue: Integer; virtual;
    function GetOldCODIGOValue: Integer; virtual;
    procedure SetCODIGOValue(const aValue: Integer); virtual;
    function GetCODIGOOBRAValue: Integer; virtual;
    function GetOldCODIGOOBRAValue: Integer; virtual;
    procedure SetCODIGOOBRAValue(const aValue: Integer); virtual;
    function GetCODIGOCONTACTOValue: Integer; virtual;
    function GetOldCODIGOCONTACTOValue: Integer; virtual;
    procedure SetCODIGOCONTACTOValue(const aValue: Integer); virtual;
    function GetFECHAALTAValue: DateTime; virtual;
    function GetOldFECHAALTAValue: DateTime; virtual;
    procedure SetFECHAALTAValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    function GetOldUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetFECHAValue: DateTime; virtual;
    function GetOldFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetCLASEValue: String; virtual;
    function GetOldCLASEValue: String; virtual;
    procedure SetCLASEValue(const aValue: String); virtual;
    function GetACEPTADOValue: String; virtual;
    function GetOldACEPTADOValue: String; virtual;
    procedure SetACEPTADOValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    function GetOldTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetPRESUPUESTOINICIALValue: Float; virtual;
    function GetOldPRESUPUESTOINICIALValue: Float; virtual;
    procedure SetPRESUPUESTOINICIALValue(const aValue: Float); virtual;
    function GetPRESUPUESTOFINALValue: Float; virtual;
    function GetOldPRESUPUESTOFINALValue: Float; virtual;
    procedure SetPRESUPUESTOFINALValue(const aValue: Float); virtual;
    function GetAPLICARETENCIONValue: String; virtual;
    function GetOldAPLICARETENCIONValue: String; virtual;
    procedure SetAPLICARETENCIONValue(const aValue: String); virtual;
    function GetRETENCIONValue: Float; virtual;
    function GetOldRETENCIONValue: Float; virtual;
    procedure SetRETENCIONValue(const aValue: Float); virtual;
    function GetTIEMPORETENCIONValue: String; virtual;
    function GetOldTIEMPORETENCIONValue: String; virtual;
    procedure SetTIEMPORETENCIONValue(const aValue: String); virtual;
    function GetIMPORTERETENCIONValue: Float; virtual;
    function GetOldIMPORTERETENCIONValue: Float; virtual;
    procedure SetIMPORTERETENCIONValue(const aValue: Float); virtual;
    function GetNOMBREValue: String; virtual;
    function GetOldNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;

    { Properties }
    property CODIGO : Integer read GetCODIGOValue write SetCODIGOValue;
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property CODIGOOBRA : Integer read GetCODIGOOBRAValue write SetCODIGOOBRAValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property CODIGOCONTACTO : Integer read GetCODIGOCONTACTOValue write SetCODIGOCONTACTOValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property FECHAALTA : DateTime read GetFECHAALTAValue write SetFECHAALTAValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property USUARIO : String read GetUSUARIOValue write SetUSUARIOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property FECHA : DateTime read GetFECHAValue write SetFECHAValue;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property CLASE : String read GetCLASEValue write SetCLASEValue;
    property OldCLASE : String read GetOldCLASEValue;
    property ACEPTADO : String read GetACEPTADOValue write SetACEPTADOValue;
    property OldACEPTADO : String read GetOldACEPTADOValue;
    property TIPO : String read GetTIPOValue write SetTIPOValue;
    property OldTIPO : String read GetOldTIPOValue;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property PRESUPUESTOINICIAL : Float read GetPRESUPUESTOINICIALValue write SetPRESUPUESTOINICIALValue;
    property OldPRESUPUESTOINICIAL : Float read GetOldPRESUPUESTOINICIALValue;
    property PRESUPUESTOFINAL : Float read GetPRESUPUESTOFINALValue write SetPRESUPUESTOFINALValue;
    property OldPRESUPUESTOFINAL : Float read GetOldPRESUPUESTOFINALValue;
    property APLICARETENCION : String read GetAPLICARETENCIONValue write SetAPLICARETENCIONValue;
    property OldAPLICARETENCION : String read GetOldAPLICARETENCIONValue;
    property RETENCION : Float read GetRETENCIONValue write SetRETENCIONValue;
    property OldRETENCION : Float read GetOldRETENCIONValue;
    property TIEMPORETENCION : String read GetTIEMPORETENCIONValue write SetTIEMPORETENCIONValue;
    property OldTIEMPORETENCION : String read GetOldTIEMPORETENCIONValue;
    property IMPORTERETENCION : Float read GetIMPORTERETENCIONValue write SetIMPORTERETENCIONValue;
    property OldIMPORTERETENCION : Float read GetOldIMPORTERETENCIONValue;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property OldNOMBRE : String read GetOldNOMBREValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IProyectosObraDelta }
  IProyectosObraDelta = interface(IProyectosObra)
  ['{0369AC96-A644-4E5C-B42F-8C710266D30F}']
    { Property getters and setters }
    function GetOldCODIGOValue : Integer;
    function GetOldCODIGOOBRAValue : Integer;
    function GetOldDESCRIPCIONValue : String;
    function GetOldTIPOValue : String;
    function GetOldTERMINADOValue : Integer;

    { Properties }
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldTIPO : String read GetOldTIPOValue;
    property OldTERMINADO : Integer read GetOldTERMINADOValue;
  end;

  { TProyectosObraBusinessProcessorRules }
  TProyectosObraBusinessProcessorRules = class(TDABusinessProcessorRules, IProyectosObra, IProyectosObraDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOValue: Integer; virtual;
    function GetOldCODIGOValue: Integer; virtual;
    procedure SetCODIGOValue(const aValue: Integer); virtual;
    function GetCODIGOOBRAValue: Integer; virtual;
    function GetOldCODIGOOBRAValue: Integer; virtual;
    procedure SetCODIGOOBRAValue(const aValue: Integer); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    function GetOldTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetTERMINADOValue: Integer; virtual;
    function GetOldTERMINADOValue: Integer; virtual;
    procedure SetTERMINADOValue(const aValue: Integer); virtual;

    { Properties }
    property CODIGO : Integer read GetCODIGOValue write SetCODIGOValue;
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property CODIGOOBRA : Integer read GetCODIGOOBRAValue write SetCODIGOOBRAValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property TIPO : String read GetTIPOValue write SetTIPOValue;
    property OldTIPO : String read GetOldTIPOValue;
    property TERMINADO : Integer read GetTERMINADOValue write SetTERMINADOValue;
    property OldTERMINADO : Integer read GetOldTERMINADOValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers;

{ TObrasBusinessProcessorRules }
constructor TObrasBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TObrasBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TObrasBusinessProcessorRules.GetCODIGOEMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCODIGOEMPRESA];
end;

function TObrasBusinessProcessorRules.GetOldCODIGOEMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasCODIGOEMPRESA];
end;

procedure TObrasBusinessProcessorRules.SetCODIGOEMPRESAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCODIGOEMPRESA] := aValue;
end;

function TObrasBusinessProcessorRules.GetCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCODIGO];
end;

function TObrasBusinessProcessorRules.GetOldCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasCODIGO];
end;

procedure TObrasBusinessProcessorRules.SetCODIGOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCODIGO] := aValue;
end;

function TObrasBusinessProcessorRules.GetFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasFECHAALTA];
end;

function TObrasBusinessProcessorRules.GetOldFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasFECHAALTA];
end;

procedure TObrasBusinessProcessorRules.SetFECHAALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasFECHAALTA] := aValue;
end;

function TObrasBusinessProcessorRules.GetUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasUSUARIO];
end;

function TObrasBusinessProcessorRules.GetOldUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasUSUARIO];
end;

procedure TObrasBusinessProcessorRules.SetUSUARIOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasUSUARIO] := aValue;
end;

function TObrasBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasNOMBRE];
end;

function TObrasBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasNOMBRE];
end;

procedure TObrasBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasNOMBRE] := aValue;
end;

function TObrasBusinessProcessorRules.GetFECHAINIOBRValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasFECHAINIOBR];
end;

function TObrasBusinessProcessorRules.GetOldFECHAINIOBRValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasFECHAINIOBR];
end;

procedure TObrasBusinessProcessorRules.SetFECHAINIOBRValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasFECHAINIOBR] := aValue;
end;

function TObrasBusinessProcessorRules.GetFECHAFINOBRValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasFECHAFINOBR];
end;

function TObrasBusinessProcessorRules.GetOldFECHAFINOBRValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasFECHAFINOBR];
end;

procedure TObrasBusinessProcessorRules.SetFECHAFINOBRValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasFECHAFINOBR] := aValue;
end;

function TObrasBusinessProcessorRules.GetCALLEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCALLE];
end;

function TObrasBusinessProcessorRules.GetOldCALLEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasCALLE];
end;

procedure TObrasBusinessProcessorRules.SetCALLEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCALLE] := aValue;
end;

function TObrasBusinessProcessorRules.GetCODIGOPOSTALValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCODIGOPOSTAL];
end;

function TObrasBusinessProcessorRules.GetOldCODIGOPOSTALValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasCODIGOPOSTAL];
end;

procedure TObrasBusinessProcessorRules.SetCODIGOPOSTALValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCODIGOPOSTAL] := aValue;
end;

function TObrasBusinessProcessorRules.GetPOBLACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasPOBLACION];
end;

function TObrasBusinessProcessorRules.GetOldPOBLACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasPOBLACION];
end;

procedure TObrasBusinessProcessorRules.SetPOBLACIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasPOBLACION] := aValue;
end;

function TObrasBusinessProcessorRules.GetPROVINCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasPROVINCIA];
end;

function TObrasBusinessProcessorRules.GetOldPROVINCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasPROVINCIA];
end;

procedure TObrasBusinessProcessorRules.SetPROVINCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasPROVINCIA] := aValue;
end;

function TObrasBusinessProcessorRules.GetTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasTIPO];
end;

function TObrasBusinessProcessorRules.GetOldTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasTIPO];
end;

procedure TObrasBusinessProcessorRules.SetTIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasTIPO] := aValue;
end;

function TObrasBusinessProcessorRules.GetDIMENSIONESValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasDIMENSIONES];
end;

function TObrasBusinessProcessorRules.GetOldDIMENSIONESValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasDIMENSIONES];
end;

procedure TObrasBusinessProcessorRules.SetDIMENSIONESValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasDIMENSIONES] := aValue;
end;

function TObrasBusinessProcessorRules.GetHONORARIOSValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasHONORARIOS];
end;

function TObrasBusinessProcessorRules.GetOldHONORARIOSValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasHONORARIOS];
end;

procedure TObrasBusinessProcessorRules.SetHONORARIOSValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasHONORARIOS] := aValue;
end;

function TObrasBusinessProcessorRules.GetIMPORTEHONORARIOSValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasIMPORTEHONORARIOS];
end;

function TObrasBusinessProcessorRules.GetOldIMPORTEHONORARIOSValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasIMPORTEHONORARIOS];
end;

procedure TObrasBusinessProcessorRules.SetIMPORTEHONORARIOSValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasIMPORTEHONORARIOS] := aValue;
end;

function TObrasBusinessProcessorRules.GetAPLICAHONORARIOSValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasAPLICAHONORARIOS];
end;

function TObrasBusinessProcessorRules.GetOldAPLICAHONORARIOSValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasAPLICAHONORARIOS];
end;

procedure TObrasBusinessProcessorRules.SetAPLICAHONORARIOSValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasAPLICAHONORARIOS] := aValue;
end;

function TObrasBusinessProcessorRules.GetTOTALPRESUPUESTOSINIValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasTOTALPRESUPUESTOSINI];
end;

function TObrasBusinessProcessorRules.GetOldTOTALPRESUPUESTOSINIValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasTOTALPRESUPUESTOSINI];
end;

procedure TObrasBusinessProcessorRules.SetTOTALPRESUPUESTOSINIValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasTOTALPRESUPUESTOSINI] := aValue;
end;

function TObrasBusinessProcessorRules.GetTOTALPRESUPUESTOSFINValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasTOTALPRESUPUESTOSFIN];
end;

function TObrasBusinessProcessorRules.GetOldTOTALPRESUPUESTOSFINValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasTOTALPRESUPUESTOSFIN];
end;

procedure TObrasBusinessProcessorRules.SetTOTALPRESUPUESTOSFINValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasTOTALPRESUPUESTOSFIN] := aValue;
end;

function TObrasBusinessProcessorRules.GetCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCODIGOCONTACTO];
end;

function TObrasBusinessProcessorRules.GetOldCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasCODIGOCONTACTO];
end;

procedure TObrasBusinessProcessorRules.SetCODIGOCONTACTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasCODIGOCONTACTO] := aValue;
end;

function TObrasBusinessProcessorRules.GetNOMBRECLIENTEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasNOMBRECLIENTE];
end;

function TObrasBusinessProcessorRules.GetOldNOMBRECLIENTEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ObrasNOMBRECLIENTE];
end;

procedure TObrasBusinessProcessorRules.SetNOMBRECLIENTEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ObrasNOMBRECLIENTE] := aValue;
end;


{ TContactosObraBusinessProcessorRules }
constructor TContactosObraBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TContactosObraBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TContactosObraBusinessProcessorRules.GetCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ContactosObraCODIGOOBRA];
end;

function TContactosObraBusinessProcessorRules.GetOldCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ContactosObraCODIGOOBRA];
end;

procedure TContactosObraBusinessProcessorRules.SetCODIGOOBRAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ContactosObraCODIGOOBRA] := aValue;
end;

function TContactosObraBusinessProcessorRules.GetCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ContactosObraCODIGOCONTACTO];
end;

function TContactosObraBusinessProcessorRules.GetOldCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ContactosObraCODIGOCONTACTO];
end;

procedure TContactosObraBusinessProcessorRules.SetCODIGOCONTACTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ContactosObraCODIGOCONTACTO] := aValue;
end;

function TContactosObraBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ContactosObraNOMBRE];
end;

function TContactosObraBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ContactosObraNOMBRE];
end;

procedure TContactosObraBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ContactosObraNOMBRE] := aValue;
end;

function TContactosObraBusinessProcessorRules.GetCATEGORIASValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ContactosObraCATEGORIAS];
end;

function TContactosObraBusinessProcessorRules.GetOldCATEGORIASValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ContactosObraCATEGORIAS];
end;

procedure TContactosObraBusinessProcessorRules.SetCATEGORIASValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ContactosObraCATEGORIAS] := aValue;
end;


{ TRefrescoContactosObraBusinessProcessorRules }
constructor TRefrescoContactosObraBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TRefrescoContactosObraBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TRefrescoContactosObraBusinessProcessorRules.GetCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoContactosObraCODIGOOBRA];
end;

function TRefrescoContactosObraBusinessProcessorRules.GetOldCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoContactosObraCODIGOOBRA];
end;

procedure TRefrescoContactosObraBusinessProcessorRules.SetCODIGOOBRAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoContactosObraCODIGOOBRA] := aValue;
end;

function TRefrescoContactosObraBusinessProcessorRules.GetCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoContactosObraCODIGOCONTACTO];
end;

function TRefrescoContactosObraBusinessProcessorRules.GetOldCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoContactosObraCODIGOCONTACTO];
end;

procedure TRefrescoContactosObraBusinessProcessorRules.SetCODIGOCONTACTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoContactosObraCODIGOCONTACTO] := aValue;
end;

function TRefrescoContactosObraBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoContactosObraNOMBRE];
end;

function TRefrescoContactosObraBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoContactosObraNOMBRE];
end;

procedure TRefrescoContactosObraBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoContactosObraNOMBRE] := aValue;
end;

function TRefrescoContactosObraBusinessProcessorRules.GetCATEGORIASValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoContactosObraCATEGORIAS];
end;

function TRefrescoContactosObraBusinessProcessorRules.GetOldCATEGORIASValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoContactosObraCATEGORIAS];
end;

procedure TRefrescoContactosObraBusinessProcessorRules.SetCATEGORIASValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoContactosObraCATEGORIAS] := aValue;
end;


{ TRefrescoObrasBusinessProcessorRules }
constructor TRefrescoObrasBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TRefrescoObrasBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TRefrescoObrasBusinessProcessorRules.GetCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoObrasCODIGO];
end;

function TRefrescoObrasBusinessProcessorRules.GetOldCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoObrasCODIGO];
end;

procedure TRefrescoObrasBusinessProcessorRules.SetCODIGOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoObrasCODIGO] := aValue;
end;

function TRefrescoObrasBusinessProcessorRules.GetNOMBRECLIENTEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoObrasNOMBRECLIENTE];
end;

function TRefrescoObrasBusinessProcessorRules.GetOldNOMBRECLIENTEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoObrasNOMBRECLIENTE];
end;

procedure TRefrescoObrasBusinessProcessorRules.SetNOMBRECLIENTEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoObrasNOMBRECLIENTE] := aValue;
end;


{ TPresupuestosObraBusinessProcessorRules }
constructor TPresupuestosObraBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TPresupuestosObraBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TPresupuestosObraBusinessProcessorRules.GetCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraCODIGO];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraCODIGO];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetCODIGOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraCODIGO] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraCODIGOOBRA];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraCODIGOOBRA];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetCODIGOOBRAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraCODIGOOBRA] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraCODIGOCONTACTO];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraCODIGOCONTACTO];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetCODIGOCONTACTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraCODIGOCONTACTO] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraFECHAALTA];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraFECHAALTA];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetFECHAALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraFECHAALTA] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraUSUARIO];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraUSUARIO];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetUSUARIOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraUSUARIO] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraFECHA];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraFECHA];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetFECHAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraFECHA] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetCLASEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraCLASE];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldCLASEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraCLASE];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetCLASEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraCLASE] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetACEPTADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraACEPTADO];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldACEPTADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraACEPTADO];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetACEPTADOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraACEPTADO] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraTIPO];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraTIPO];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetTIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraTIPO] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraDESCRIPCION];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraDESCRIPCION];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraDESCRIPCION] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetPRESUPUESTOINICIALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraPRESUPUESTOINICIAL];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldPRESUPUESTOINICIALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraPRESUPUESTOINICIAL];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetPRESUPUESTOINICIALValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraPRESUPUESTOINICIAL] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetPRESUPUESTOFINALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraPRESUPUESTOFINAL];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldPRESUPUESTOFINALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraPRESUPUESTOFINAL];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetPRESUPUESTOFINALValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraPRESUPUESTOFINAL] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetAPLICARETENCIONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraAPLICARETENCION];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldAPLICARETENCIONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraAPLICARETENCION];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetAPLICARETENCIONValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraAPLICARETENCION] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetRETENCIONValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraRETENCION];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldRETENCIONValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraRETENCION];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetRETENCIONValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraRETENCION] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetTIEMPORETENCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraTIEMPORETENCION];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldTIEMPORETENCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraTIEMPORETENCION];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetTIEMPORETENCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraTIEMPORETENCION] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetIMPORTERETENCIONValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraIMPORTERETENCION];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldIMPORTERETENCIONValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraIMPORTERETENCION];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetIMPORTERETENCIONValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraIMPORTERETENCION] := aValue;
end;

function TPresupuestosObraBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraNOMBRE];
end;

function TPresupuestosObraBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_PresupuestosObraNOMBRE];
end;

procedure TPresupuestosObraBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_PresupuestosObraNOMBRE] := aValue;
end;


{ TRefrescoPresupuestosObraBusinessProcessorRules }
constructor TRefrescoPresupuestosObraBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TRefrescoPresupuestosObraBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraCODIGO];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraCODIGO];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetCODIGOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraCODIGO] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraCODIGOOBRA];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraCODIGOOBRA];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetCODIGOOBRAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraCODIGOOBRA] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraCODIGOCONTACTO];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraCODIGOCONTACTO];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetCODIGOCONTACTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraCODIGOCONTACTO] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraFECHAALTA];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraFECHAALTA];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetFECHAALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraFECHAALTA] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraUSUARIO];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraUSUARIO];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetUSUARIOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraUSUARIO] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraFECHA];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraFECHA];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetFECHAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraFECHA] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetCLASEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraCLASE];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldCLASEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraCLASE];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetCLASEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraCLASE] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetACEPTADOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraACEPTADO];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldACEPTADOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraACEPTADO];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetACEPTADOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraACEPTADO] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraTIPO];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraTIPO];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetTIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraTIPO] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraDESCRIPCION];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraDESCRIPCION];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraDESCRIPCION] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetPRESUPUESTOINICIALValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraPRESUPUESTOINICIAL];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldPRESUPUESTOINICIALValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraPRESUPUESTOINICIAL];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetPRESUPUESTOINICIALValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraPRESUPUESTOINICIAL] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetPRESUPUESTOFINALValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraPRESUPUESTOFINAL];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldPRESUPUESTOFINALValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraPRESUPUESTOFINAL];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetPRESUPUESTOFINALValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraPRESUPUESTOFINAL] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetAPLICARETENCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraAPLICARETENCION];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldAPLICARETENCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraAPLICARETENCION];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetAPLICARETENCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraAPLICARETENCION] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetRETENCIONValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraRETENCION];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldRETENCIONValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraRETENCION];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetRETENCIONValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraRETENCION] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetTIEMPORETENCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraTIEMPORETENCION];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldTIEMPORETENCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraTIEMPORETENCION];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetTIEMPORETENCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraTIEMPORETENCION] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetIMPORTERETENCIONValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraIMPORTERETENCION];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldIMPORTERETENCIONValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraIMPORTERETENCION];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetIMPORTERETENCIONValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraIMPORTERETENCION] := aValue;
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraNOMBRE];
end;

function TRefrescoPresupuestosObraBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_RefrescoPresupuestosObraNOMBRE];
end;

procedure TRefrescoPresupuestosObraBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_RefrescoPresupuestosObraNOMBRE] := aValue;
end;


{ TProyectosObraBusinessProcessorRules }
constructor TProyectosObraBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TProyectosObraBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TProyectosObraBusinessProcessorRules.GetCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraCODIGO];
end;

function TProyectosObraBusinessProcessorRules.GetOldCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ProyectosObraCODIGO];
end;

procedure TProyectosObraBusinessProcessorRules.SetCODIGOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraCODIGO] := aValue;
end;

function TProyectosObraBusinessProcessorRules.GetCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraCODIGOOBRA];
end;

function TProyectosObraBusinessProcessorRules.GetOldCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ProyectosObraCODIGOOBRA];
end;

procedure TProyectosObraBusinessProcessorRules.SetCODIGOOBRAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraCODIGOOBRA] := aValue;
end;

function TProyectosObraBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraDESCRIPCION];
end;

function TProyectosObraBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ProyectosObraDESCRIPCION];
end;

procedure TProyectosObraBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraDESCRIPCION] := aValue;
end;

function TProyectosObraBusinessProcessorRules.GetTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraTIPO];
end;

function TProyectosObraBusinessProcessorRules.GetOldTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ProyectosObraTIPO];
end;

procedure TProyectosObraBusinessProcessorRules.SetTIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraTIPO] := aValue;
end;

function TProyectosObraBusinessProcessorRules.GetTERMINADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraTERMINADO];
end;

function TProyectosObraBusinessProcessorRules.GetOldTERMINADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ProyectosObraTERMINADO];
end;

procedure TProyectosObraBusinessProcessorRules.SetTERMINADOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ProyectosObraTERMINADO] := aValue;
end;


initialization
  RegisterBusinessProcessorRules(RID_ObrasDelta, TObrasBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_ContactosObraDelta, TContactosObraBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_RefrescoContactosObraDelta, TRefrescoContactosObraBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_RefrescoObrasDelta, TRefrescoObrasBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_PresupuestosObraDelta, TPresupuestosObraBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_RefrescoPresupuestosObraDelta, TRefrescoPresupuestosObraBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_ProyectosObraDelta, TProyectosObraBusinessProcessorRules);

end.
